var platform = new String(navigator.platform);
dump("Platform is " + platform + "\n");
if(platform.search(/^Win/)) {
	var fileSeparator = "/";
} else {
	var fileSeparator = "\\";
}

var projectFile = false;
var maxRowCount = 4;
var rowCounts = new Array(1);
var catsDrawn = 0;
var projectInfo = new Object();
projectInfo.namedCategories = 0;

if(!opener.projectFile) {

} else {
	projectFile = opener.projectFile;
}

function getProjectInfo(xmlDoc) {
	var projectNode = xmlDoc.getElementsByTagName("project")[0];
	for(var i=0; i< projectNode.attributes.length;i++) {
		dump(i + " " + projectNode.attributes.item(i) + " " + projectNode.attributes.item(i).nodeName + " " + projectNode.attributes.item(i).nodeValue + "\n");
		projectInfo[projectNode.attributes.item(i).nodeName] = projectNode.attributes.item(i).nodeValue;
	}
	
}

function doCatSortLoad() {
	
	var du=new DirUtils(); 
	var tempCat, tempCatName;
//	var dataPath = du.getChromeDir() + '\\uzcardsort\\content\\data\\flavors.xml';
	var dataPath = projectFile;
	var dataFile = new File(dataPath);
	dump("Found datafile? " + dataPath + " "+ dataFile.exists() + "\n");
	dataFile.open("r");
	var xmlString = dataFile.read();
	dataFile.close();
	xmlDoc = new DOMParser().parseFromString(xmlString, "text/xml");
	dump("Read doc " + xmlDoc.childNodes.item(0).nodeName + "\n");
	getProjectInfo(xmlDoc);
	// Manage category creation
	if(projectInfo.create) document.getElementById("add-container-button").disabled = false;
	// Get the categories and build the drop targets
	var colCategory = xmlDoc.getElementsByTagName("category");
	dump("Read " + colCategory.length + "\n");
	for(var i=0; i<colCategory.length;i++) {
		tempCat = colCategory[i];
		//dump("a cat " + tempCat.nodeName + " " + tempCat.getAttribute("name") + "\n");
		tempCatName = tempCat.getAttribute("name") ;
		if(tempCatName== "unsorted") {
			dump("pop main \n");
			catSortPopulateMain(tempCat);
		} else {
			dump("pop access \n");
			catSortPopulateAccessory(tempCat);
		}		
	}
	dump("pop remain \n");
	drawRemainingCats();
}

function catSortPopulateMain(colCats) {
	var sourceContainer = document.getElementById("itemsource");
	var tempNode
	for(var i=0; i<colCats.childNodes.length;i++) {
		dump(colCats.childNodes.item(i).nodeName + '\n');
		if(colCats.childNodes.item(i).nodeName == "item") {
			dump(colCats.childNodes.item(i).getAttribute("label") + "\n");
			tempNode = document.createElement("listitem");
			tempNode.setAttribute("label", colCats.childNodes.item(i).getAttribute("label"));
			sourceContainer.appendChild(tempNode);
		}
	}
}

function getNameNodeFromDropCat(cat) {
	//dump(cat.childNodes.item(0).nodeName + "\n");
	//dump(cat.childNodes.item(0).childNodes.item(0).nodeName + "\n");
	//dump(cat.childNodes.item(0).childNodes.item(0).childNodes.item(0).nodeName + "\n");
	
return cat.childNodes.item(0).childNodes.item(0).childNodes.item(0).childNodes.item(1);
}

function getListboxFromDropCat(cat) {
	//dump(cat.childNodes.item(0).nodeName + "\n");
	//dump(cat.childNodes.item(0).childNodes.item(0).nodeName + "\n");
	//dump(cat.childNodes.item(0).childNodes.item(0).childNodes.item(0).nodeName + "\n");
	
return cat.childNodes.item(0).childNodes.item(0).childNodes.item(1);
}

function catSortPopulateAccessory(colCats) {
	dump("popping accessory" + colCats.getAttribute("label") + "\n");
	
	catsDrawn++;
	var tempNode;
	var tempLabelNode;
	var tempListboxNode;
	var rowNodes = new Array(1);
	rowNodes[0] = document.getElementById("catsort-row-1");
	rowNodes[1] = document.getElementById("catsort-row-2");
	
	var row = 0;
	if((catsDrawn/projectInfo.numcats) > .5) {
		row = 1;
	} else {
		row = 0;
	}
	dump(catsDrawn + " Pondering row " + catsDrawn + " " + projectInfo.numcats + " yielding " + (catsDrawn/projectInfo.numcats) + "\n");
	tempNode = document.getElementById("dropcat-template").cloneNode(true);
	tempNode.setAttribute("hidden", false);
	// set Category Label
	tempNode.setAttribute("id", "dropcat" + catsDrawn);
	tempLabelNode =getNameNodeFromDropCat(tempNode);
	tempLabelNode.value= colCats.getAttribute("label");
	tempLabelNode.setAttribute("id", "dropcat" + catsDrawn + "name");
	// Set listbox id
	tempListBoxNode = getListboxFromDropCat(tempNode);
	tempListBoxNode.setAttribute("id", "dropcat" + catsDrawn + "list");
	if(!projectInfo.rename) tempLabelNode.disabled = true;
	rowNodes[row].appendChild(tempNode);

}

function drawRemainingCats() {
	dump("Drawing remaining with " + projectInfo.numcats + " " + catsDrawn + " leaving " +  (projectInfo.numcats - catsDrawn) + "\n");
	var tempListBoxNode, tempLabelNode;
	var drawNum = projectInfo.numcats - catsDrawn - 1;
	var rowNodes = new Array(1);
	rowNodes[0] = document.getElementById("catsort-row-1");
	rowNodes[1] = document.getElementById("catsort-row-2");
	
	var row;

	if(drawNum > 0) {
		
		for(var i=1;i<=drawNum+1;i++) {
			catsDrawn++;
			dump(catsDrawn + "Pondering row " + catsDrawn + " " + projectInfo.numcats + " yielding " + (catsDrawn/projectInfo.numcats) + "\n");
			if((catsDrawn/projectInfo.numcats) > .5) {
				dump("doing row 1\n");
				row = 1;
			} else {
				row = 0;
				dump("doing row 0\n");
			}
			tempNode = document.getElementById("dropcat-template").cloneNode(true);
			tempNode.setAttribute("id", "dropcat" + catsDrawn);
			tempLabelNode =getNameNodeFromDropCat(tempNode);
			tempLabelNode.setAttribute("id", "dropcat" + catsDrawn + "name");
			tempListBoxNode = getListboxFromDropCat(tempNode);
			tempListBoxNode.setAttribute("id", "dropcat" + catsDrawn + "list");
			
			
			tempNode.setAttribute("hidden", false);
			rowNodes[row].appendChild(tempNode);

		}
	}
}

/*
0 [object Attr] name Flavorishish2
1 [object Attr] rename false
2 [object Attr] create true
3 [object Attr] label A flavorish experience
4 [object Attr] numcats 6
*/
